/*******************************************************************************
* \[XFUL024TF_Touch_MP3_Player_TEST.C
*
* TEST̖ړI
*@ @@UL024TF̃Xbgɑ}ĂAmicroSDJ[hɊi[Ă
*@@@@yt@C̃XgAJ[QVGAtɕ\Ă݂B
* @A@microSDJ[hɊi[ĂACӂ̈ʒủyt@CiMP3yсAWAVj
*@@@@ǏoAĐB
*@ B@UL024TF̃^b`plgA4̃{^ŁASKIPHOMEyсA
*@@@@VOL+, VOL-@\Ă݂B
*
* eXgdlTv
* @@@SDɊi[ĂAMP3t@CAő16܂œǏoÃt@CXg
* @@@AJ[QVGAtɕ\B
*@@@ 16ɖȂꍇ́A̐̃t@CXg\B
*@@@ ́AXN[@\͖ƂB
*@ A@ʏ^b`Ȃ΁Aŏ̋Ȃ珇ő16Ȗڂ܂ł̍ĐJԂA
*@@@ [vĐsB
*@@@ Đ̋Ȃ̐擪ɁA}[J[i''j\B
*@@@ ړȂĐJԂB
*@ B@ĐɁASKIP{^^b`ƁAĐ𒆒fA̋Ȃ̍ĐɈڂB
*@ C@ĐɁAHOME{^^b`ƁAĐ𒆒fAŏ̋Ȃ̍Đɖ߂B
*@ D@ĐɁAVOL+{^^b`ƁAʂAbvB
*@ E@ĐɁAVOL-{^^b`ƁAʂ_EB
*
* t@CVXeFMicrochip MMD File System V1.2.1@FAT16iFAT32݊j
* 2.4inch J[QVGAt(aitendo): UL024TF
* MPEG Audio Codec LSI: VS1011eiEXT CLK:12.288MHz)
*
* Condition:
* 8MHz External X'tal Oscillator, 20x PLL (8MHzx20= 160MHz)
* Fcy=160MHz/2=80MHz, Tcy=12.5ns
*
* CPU: PIC32MX340F256H
*
* N.Ishii   2016.7.18
**********************************************************************************/
#include <plib.h>		/* PIC32 peripheral library */
#include "colorlcd_libdsPICVH.h"
#include <FSIO.h>

#include <VS1011.h>

// RtBM[Vݒ
// CPU=80MHz Peri=80MHz,HS+PLL,Divider=1/2,PLL=x20,WDT=Off
#pragma config FNOSC=PRIPLL, POSCMOD=HS, FPLLIDIV=DIV_2
#pragma config FPLLMUL=MUL_20, FPBDIV=DIV_1, FPLLODIV=DIV_1
#pragma config FWDTEN=OFF, ICESEL=ICS_PGx2

/// ^b`{^Wf[^
short Button[4][2] = {{350,870},	// [0]F{^-1FSKIP
		      {170,890},	// [1]F{^-2FHOME
		      {160,750},	// [2]F{^-3FVOL+
		      {100,990}		// [3]F{^-4FVOL-
};

char str_N[]= "Nxx";	// FileNo\p
char str_V[]= "Vxx";	// ʕ\p

short Count;
char MsgScrn[] = "X=xxxx Y=xxxx";	// W\

/// t@CVXepϐ
FSFILE *fptr;
size_t result;
SearchRec Record;
SearchRec *rptr = &Record;

char FileName[20][13];	// 2zF@őA20t@CŁA1t@C13i8{'.MP3'{NULLj\

/// VS1011pϐ
short Volume, BASS;
unsigned char Buffer[256];

/// O[oϐ
short FileNo;
short i;
short SW;
char ChgFlag;

/// vg^Cv
void DispFiles(void);
void SetupScreen(void);
short Getscreen(unsigned int chn);
short CheckBtn(short x, short y);
void TouchFunc(void);
void MakerDisp(void);

void itostring(char digit, unsigned short data, char *buffer);

/******* C[` ***********/
int main(void)
{
	//VXeœKݒ
	SYSTEMConfigPerformance(80000000);
	mJTAGPortEnable(DEBUG_JTAGPORT_OFF);	// JTAG𖳌 

	//I/Oݒ
	AD1PCFG = 0xFFFF;	// SăfW^Ɂi^b`pݒ́AAN4(X-)AAN3(Y+)Ȃ̂ŁA0xFFE7j

	TRISE = 0x0000;		// LCDf[^oXiDB0-DB7jI[o
	TRISD = 0xFFA7;		// LCD_CS,RESETFSďóEfobOLEDFóESW2-5F́Agps͓͐ݒ
	TRISB = 0x4FC7;		// VS1011_CS,RESET,DCSFóADREQF́ESD_CSFóALCD_WR,LCD_RSFóAgps͓͐ݒ
						// íAVS1011͖gpAg\Ȃ̂ŁA̐ݒɂĂj
	TRISF = 0xFFFC;		// F|[g͖gpARF0,RF1̂ݏo͐ݒɂ

	LATDbits.LATD3 = 1;	// fobOLED

	/// t\̏
	Glcd_Init();
	Glcd_Clear(BLACK);
	Glcd_Str(0, 0, "Touch MP3 Player Test", CYAN, BLACK);
	delay_ms(1000);

	Glcd_Clear(BLACK);

	/// VS1011ȅ
	VS1011_Init();	// Initialize VS1011 Port+ SPI2(CKP=4M)+ SDI_TestMode+ CLK Doubler

	Volume = 0x08;	// Set Volume = -8[dB]
	SetVolume(Volume, Volume);

	BASS = 0;	// Set Bass Boost = off
	SetBassBoost(BASS, 15);

	delay_ms(1000);

	// Start VS1011e Sine Test
//	VS1011_SineTest();	// Start Sin_5kHz

	/// ϐ
	Count= 0;
	SetupScreen();				// ADCݒύX

	FileNo= 0;
	SW= -1;
	ChgFlag= 0;

	/// J[h}܂ő҂t@CLmFiCD̖UL024TFgp̂߁AMDD_MediaDetect()̖߂lIɁA'1'F}ɂĂBj
	while(fptr == 0){
		Glcd_Clear(BLACK);	// ʏ

		if(!MDD_MediaDetect()){			// J[h}H
			Glcd_Str(0, 0, "Wait Card Insert!", CYAN, BLACK);	// }҂bZ[Wi͂͏ɎsȂj
		}
		else{	// ɃJ[h}ԂsB
			/*** t@CI[vƃt@C\ ***/
			Glcd_Str(0, 1, "Find Card OK!", CYAN, BLACK);
			FSInit();					// FS

			/* ŏ̃t@C̃T[` */
			result = FindFirst("*.*", ATTR_ARCHIVE, rptr);

			if(result != 0){				// t@C肩H
				Glcd_Str(0, 1, "Find No File?", CYAN, BLACK);		// t@CbZ[W
			}
			else
				break;					// t@CŔ
		}
		delay_ms(500);					// 0.5bƂɌJԂ
	}

	/// t@Cłꍇ̏
	DispFiles();						// t@Cꗗ\

	Glcd_Char(16, 8, 0xE9, GREEN, BLACK);	// {^-1FSelect \iLN^j
	Glcd_Char(25, 8, 0xE9, YELLOW, BLACK);	// {^-2FEnter \iLN^j

	Glcd_Char(25, 0, 0xEB, CYAN, BLACK);	// {^-1FVOL+ \iLN^j
	Glcd_Char(25, 16, 0xED, CYAN, BLACK);	// {^-1FVOL- \iLN^j

	itostring(2, 64-Volume, str_V+1);
	Glcd_Str(21, 0, str_V, WHITE, BLACK);	// 'Vxx'\

	Glcd_Char(0, 0, 0xE4, GREEN, BLACK);	// ''Iʒui擪jɕ\);

	/// C@[v
	while(1) {
		/// t@CNo.\
		itostring(2, FileNo, str_N+1);
		Glcd_Str(21, 16, str_N, WHITE, BLACK);	// 'Nxx'\

		/// Iꂽt@C̍Đ
		fptr = FSfopen(FileName[FileNo], "r");			// t@CJ

		if (fptr != 0) {		// Success File Open ?
								// At@Ci0)I[v悤ƂƃI[vG[Ffptr == 0ɂȂB
			// Out of Music Data As Far as EOF of File 
			do{
				/// XVtO`FbNƐiʃ{^j
				if(ChgFlag){		// XV肩H
					ChgFlag = 0;	// tONA
					SetVolume(Volume, Volume);	// ʐݒ
				}

				MP3_XDCS_IO = 0;

				/// File Read (Unit 256Byte)
				result = FSfread(Buffer, 1, 256, fptr);

				for( i= 0; i<result; i++) {	// Repeat till Number of Reading Bytes(result)
					SendData(Buffer[i]);	// Send of Music Data
				}

				TouchFunc();	// ^b`ꂽ{^fiSW̒lŔj

			} while ((result != 0)&&(SW== -1));	// ĐrɃ^b`AEOFłȂꍇJԂ

			MP3_XDCS_IO = 1;

			delay_ms(10);

			/// Processing End of Play
			FSfclose(fptr);			// File Close
			PlayEnd();			// Processing End of Play

			/// ĐɃ^b`ȂA̓{^^b`ꂽꍇ̏iʃ{^ȊOj
			switch(SW){
				case 0:	/// {^-1FSkip
					MakerDisp();	// I}[J[ړ\Ǝ̍Đt@CNo擾
					SW= -1;
					break;

				case 1:	/// {^-2FHome
					Glcd_Char(0, FileNo, 0x20, BLACK, BLACK);// ݈ʒúAILN^''NA

					FileNo = 0;
					Glcd_Char(0, FileNo, 0xE4, GREEN, BLACK);	// ''Iʒui擪jɕ\

					break;

				default: /// 0, 1ȊOi-1jFĐrɃ^b`ŋȍĐI玟̋ȂĐiiv[vj
					MakerDisp();	// I}[J[ړ\Ǝ̍Đt@CNo擾
					break;
			}
		}
		else {	// I[vG[
			Glcd_Char(0, FileNo, 0x20, BLACK, BLACK);// ݈ʒúAILN^''NA
			FileNo= 0;
			Glcd_Char(0, FileNo, 0xE4, GREEN, BLACK);	// ''Iʒui擪jɕ\
		}
	}

}

//--------------------------------------------------------------------------------

/******************************************
*  ^b`XN[@AiO 
*  ݂gȂ
*******************************************/
void TouchFunc(void)
{
	static short i, Xset, Yset, Xold, Yold;

	/// ^b`XN[ṕAAD1PCFGLWX^̐ݒɖ߂
	AD1PCFG = 0xFFE7;	// AN4(X-)AAN3(Y+)

	///// ^b``FbN
	/// XW
	TRISBbits.TRISB3 = 0;			// RB3(Y+), RE7(Y-) is output
	TRISEbits.TRISE7 = 0;

	LATBbits.LATB3 = 1;			// Set Voltage
	LATEbits.LATE7 = 0;

	TRISBbits.TRISB4 = 1;			// RB4(AN4):X-
	TRISEbits.TRISE6 = 1;			// RE6(DB6):X+́A͐ݒŁAHi-ZƂ

	for(i=0; i<100; i++) Nop();		// [d҂ 11usec

	Xset = Getscreen(0x00040000);		// Wl擾

	/// YW
	TRISEbits.TRISE6 = 0;			// RE6(X+), RB4(X-) is output
	TRISBbits.TRISB4 = 0;

	LATEbits.LATE6 = 1;			// Set Voltage
	LATBbits.LATB4 = 0;

	TRISBbits.TRISB3 = 1;			// RB3(AN3):Y+
	TRISEbits.TRISE7 = 1;			// RE7(DB7):Y-́A͐ݒŁAHi-ZƂ

	for(i=0; i<100; i++) Nop();		// [d҂ 11usec

	Yset = Getscreen(0x00030000);	// Wl擾

	/// X,YW͌ALCDMƌps̐ݒSāAfW^o͂ɖ߂
	AD1PCFG = 0xFFFF;			// SăfW^o
	TRISBbits.TRISB4 = 0;			// WRo
	TRISBbits.TRISB3 = 0;			// RSo
	TRISEbits.TRISE6 = 0;			// DB6o
	TRISEbits.TRISE7 = 0;			// DB7o

	/// ^b`ĂȂƂ̉
	if((Xset > 60)&&(Yset < 1000)){
		/// mȃ^b`̌o
		if((abs(Xset - Xold) < 15) && abs(Yset - Yold) < 15){
			Count++;
			if(Count >= 3){
				Count = 0;
				SW= CheckBtn(Xset, Yset);	// ꂽ{^f

				/// ʃ{^`FbN
				if(SW == 2){	// {^Q:ʃAbv
					if(Volume > 0) {	// ō0(0dB)F@64`0͈̔͂Őݒ
						Volume--;

						itostring(2, 64-Volume, str_V+1);	// 'Vxx'\F\́Aŏ0`ő64̕\ɕϊ
						Glcd_Str(21, 0, str_V, WHITE, BLACK);
					}
					ChgFlag = 1;		// ύXtOI
					SW= -1;
				}

				if(SW == 3){	// {^3:ʃ_E
					if(Volume < 64) {	// 0`64͈̔͂Őݒ	
						Volume++;

						itostring(2, 64-Volume, str_V+1);	// 'Vxx'\F\́Aŏ0`ő64̕\ɕϊ
						Glcd_Str(21, 0, str_V, WHITE, BLACK);
					}
					ChgFlag = 1;		// ύXtOI
					SW= -1;
				}

			}
		}
		else	Count = 0;

		Xold = Xset;
		Yold = Yset;
	}
	else SW= -1;
}

/*****************************************************
*   I}[J[ړ\{̍Đt@CNo擾
******************************************************/
void MakerDisp(void)
{
	FileNo++;			// ̍s

	if(FileNo < 16)	{
		Glcd_Char(0, FileNo-1, 0x20, BLACK, BLACK);	// ̑Oɕ\ĂAILN^''NA
		Glcd_Char(0, FileNo, 0xE4, GREEN, BLACK);	// ''Iʒui擪jɕ\
	}
	else{	// ŏIs𒴂ꍇA擪ɖ߂
		FileNo = 0;
		Glcd_Char(0, 15, 0x20, BLACK, BLACK);	// ̑Oɕ\ĂAILN^''NA
		Glcd_Char(0, FileNo, 0xE4, GREEN, BLACK);	// ''Iʒui擪jɕ\
	}
}

/********************************
*   W擾s֐
********************************/
short Getscreen(unsigned int chn)
{
	short i;

	AD1CON1bits.ADON = 0;
	AD1CON1bits.DONE = 0;		// 蓮̏ꍇ͕ϊJnOɁADONErbgNAKviNAȂj
	AD1CHS = chn;				// Select Channel

	AD1CON1bits.ADON = 1;
	AD1CON1bits.SAMP = 1;
	for(i=0; i<100; i++)			// Wait Aquisition 11usec
		Nop();
	AD1CON1bits.SAMP = 0;			// A/D convert start
	while(!AD1CON1bits.DONE);		// wait conversion

	return(ADC1BUF0);			// return result
}

/****************************************
*  ^b`XN[pݒύX
****************************************/
void SetupScreen(void)
{
	/* ADC̐ݒ */
	AD1CON1bits.ADON = 0;
	AD1CON1 = 0x0000;			// ADItA蓮A10bit\
	AD1CON2 = 0;				// AVdd, AVss, SCANȂ,MUXÂ
	AD1CON3 = 0x0304;			// ADpNbNFTad = 10*Tcy= 10*12.5=  125nS^TvԁF3Tad= 3*125= 375nS
								// Tad= 2* ӗpNbNiTpbclk=Tcyj* (ADCS(7:0)ݒ+1)= 2* 12.5* (4+1)
 	AD1CHS = 0x00000000;			// `lIi@S/H`lݒ͏16bitłj
	AD1PCFG = 0xFFE7;			// AN4(X-)AAN3(Y+)
	AD1CSSL = 0;				// XLȂ
	AD1CON1bits.ADON = 1;			// ADL

}

/**********************************************************
* ^b`{^菈
* ^b`|Cg̍WAꂽ{^̎No.擾
* A̒lԂ
***********************************************************/
short CheckBtn(short x, short y)
{
	short i, btn;
/*
	/// ^b`Wʒu\ifobOp)
	itostring(4, x, MsgScrn+2);
	itostring(4, y, MsgScrn+9);

	Glcd_Str(3, 16, MsgScrn, GREEN, BLACK);
*/
	/// {^`FbN
	btn = -1;
	for(i=0; i<4; i++){
		if((x > Button[i][0]-15)&&(x <	Button[i][0]+15)){
			if((y > Button[i][1]-15)&&(y < Button[i][1]+15))
				btn = i;
		}
	}

	return(btn);
}


/***************************************
* ASCIIɕϊ
****************************************/
void itostring(char digit, unsigned short data, char *buffer)
{
	char i;

	buffer += digit;					// Ō̐ʒu
	for(i=digit; i>0; i--) {			// ϊ͉ʂʂ
		buffer--;					// |C^[P
		*buffer = (data % 10) + '0';	// ASCII
		data = data / 10;				// ̌
	}
}

/***************************************************
*  t@CXg̕\
*  ő16t@C
****************************************************/
void DispFiles(void){
	short i, j;

	Glcd_Clear(BLACK);			// Sʏ

	/// t@C̕\
	i = 0;
	j = 0;

	/// ŏ̃t@C̕\Ɗi[
	while(Record.filename[j] != 0){				// ̍ŌォH
		FileName[i][j] = Record.filename[j];		// i[
		j++;
	}
	Glcd_Str(2, i++, Record.filename, CYAN, BLACK);	// ŏ̃t@C̕\

	/// ׂẴt@C̕\Ɗi[
	while(FindNext(rptr) == 0){					// ̃t@CT[`
		//// t@CłΕ\i[
		j = 0;							// |C^Zbg
		if(Record.attributes==ATTR_ARCHIVE)			// łH
			while(Record.filename[j] != 0){		// ̂̍ŌォH
				FileName[i][j] = Record.filename[j];// i[
				j++;
			}
			Glcd_Str(2, i++, Record.filename, CYAN, BLACK);		// t@C\
			if(i>=16)					// 16ڂ𒴂H
				break;					// IĔ
	}
}

